<?php

namespace Fufle\Database;

use PDO;

class ConnectionManager {
    private static $connection;

    public static function connect(string $connectionString) {
        self::$connection = new PDO($connectionString);
    }

    public static function Query(string $query, array|object $params = [], string $output = 'stdObject') {
        $stmt = self::$connection->prepare($query);
        $stmt->execute($params);
        $stmt->setFetchMode(PDO::FETCH_CLASS, $output);
        return $stmt->fetch();
    }

    public static function QueryAll(string $query, array|object $params = [], string $output = 'stdObject') {
        $stmt = self::$connection->prepare($query);
        $stmt->execute($params);
        $stmt->setFetchMode(PDO::FETCH_CLASS, $output);
        return $stmt->fetchAll();
    }
}